<template>
  <div class="questionnaire-container">
    <ObAlert
      v-if="isQuestionnaireAlertVisible"
      text="Чтобы заполнить анкету, подтвердите свое участие, нажав кнопку «Участвовать»"
      icon="info"
    />

    <ObQuestionnaire
      :groups="questionnaireValue"
      :show-func-panel="false"
      :fields-disabled="isQuestionnaireDisabled"
      :counters-disabled="true"
      :fill-mode="true"
      @state-changed="onQuestionnaireChanged(true)"
      @field-changed="onQuestionnaireChanged"
      @comment-changed="onQuestionnaireChanged"
    >
      <template slot="rightColumnBottom">
        <h4 class="uploader-title">Дополнительные файлы к анкете</h4>

        <ObUploader
          v-if="isQuestionnaireUploaderVisible"
          :multiple="true"
          @change="onChangeFiles($event)"
          :class="[ 'uploader', { 'disabled': isQuestionnaireAlertVisible } ]"
          :is-detail-emit="true"
          data-qa="uploader"
        />

        <div
          v-if="files.length"
          class="existing-files"
        >
          <div
            class="existing-file"
            v-for="file in files"
            :key="file.uuid"
            data-qa="download"
            @click="downloadFile(file)"
          >
            <span :class="[ 'existing-file-text', { 'is-link': isQuestionnaireDisabled } ]">
              {{ file.name }}
            </span>

            <i
              v-if="!isQuestionnaireDisabled"
              data-qa="deleteFile"
              @click.stop="onDeleteFile(file.uuid)"
              class="icon close existing-file-icon"
            />
          </div>
        </div>

        <span
          v-else-if="!isQuestionnaireUploaderVisible"
          class="empty-files"
        >
          Нет
        </span>
      </template>
    </ObQuestionnaire>
  </div>
</template>

<script>
  import ObAlert from 'common-components/src/obComponents/obAlert'
  import ObQuestionnaire from 'common-components/src/obComponents/obQuestionnaire'
  import ObUploader from 'common-components/src/obComponents/obUploader'
  import QuestionnaireLoading from '../mixins/questionnaire-loading'
  import { mapGetters, mapActions } from 'vuex'
  import api from '@/api'
  import moment from 'moment'

  export default {
    name: 'tender-tab-carrier-questionnaire',
    components: {
      ObAlert,
      ObUploader,
      ObQuestionnaire
    },
    mixins: [
      QuestionnaireLoading
    ],
    computed: {
      ...mapGetters({
        tender: 'tenders/tender',
        questionnaireFileUuids: 'tenders/questionnaireFileUuids',
        currentRole: 'tenders/currentRole'
      }),
      isTenderEditable () {
        return this.tender.tenderInfo.status === 'HELD'
      },
      isQuestionnaireDisabled () {
        return !this.isTenderEditable || this.tender.tenderInfo.participationStatus !== 'DRAFT'
      },
      isQuestionnaireAlertVisible () {
        return this.isTenderEditable && this.tender.tenderInfo.participationStatus === 'VIEWED'
      },
      isQuestionnaireUploaderVisible () {
        if (!this.isTenderEditable) {
          return false
        }

        return ['DRAFT', 'VIEWED'].includes(this.tender.tenderInfo.participationStatus)
      }
    },
    methods: {
      ...mapActions({
        fillTenderQuestionnaire: 'tenders/fillTenderQuestionnaire'
      }),
      async downloadFile (file) {
        const res = await api.files.getFile(file.uuid)

        const fileName = res.name
        const url = window.URL.createObjectURL(new Blob([res.data]))
        const link = document.createElement('a')

        link.href = url
        link.setAttribute('download', fileName)

        document.body.appendChild(link)

        link.click()

        document.body.removeChild(link)
      },
      onDeleteFile (uuid) {
        this.files = this.files.filter(file => file.uuid !== uuid)
        this.fileUuids = this.fileUuids.filter(fileUuid => fileUuid !== uuid)

        this.onQuestionnaireChanged()
      },
      async onChangeFiles (e) {
        if (e.added) {
          const uploadRequest = ({ uuid, file }) => {
            return new Promise((resolve, reject) => {
              api.files.postFile({ uuid, file }).then(() => {
                resolve()
              }).catch(e => {
                reject(e)
              })
            })
          }

          const delayedLog = async (item) => {
            await uploadRequest(item)
          }

          const uploadFiles = async (array) => {
            const promises = array.map(delayedLog)
            await Promise.all(promises)
          }

          await uploadFiles(e.added)

          e.added.forEach(file => this.fileUuids.push(file.uuid))
        }

        if (e.deleted) {
          this.fileUuids = this.fileUuids.filter(fileUuid => fileUuid !== e.deleted)
        }

        this.onQuestionnaireChanged()
      },
      async onQuestionnaireChanged (isStateChanged = false) {
        await api.tenders.saveQuestionnaireDraft(this.tender.filledForm.uuid, {
          tenderUuid: this.tender.tenderInfo.uuid,
          questions: this.questionnaireValue.reduce((allQuestions, group) => {
            return allQuestions.concat(group.questions.map((question) => {
              return {
                uuid: question.uuid,
                comment: question.comment,
                isAdditionalQuestion: question.isUserQuestion,
                fields: question.fields.map(({ uuid, value, type }) => {
                  if (question.type === 'SELECT') {
                    return { uuid, value: question.selected === uuid }
                  } else if (question.type === 'MULTISELECT') {
                    return { uuid, value }
                  } else if (type === 'DATE') {
                    return { uuid, value: value ? moment(value).format('YYYY-MM-DD') : '' }
                  } else if (type === 'NUMBER') {
                    return { uuid, value: Number(value) }
                  } else {
                    return { uuid, value }
                  }
                })
              }
            }))
          }, []),
          fileUuids: this.fileUuids
        })

        if (isStateChanged) {
          await this.fillTenderQuestionnaire()
        }
      }
    }
  };
</script>

<style lang="scss" scoped>
  @import '~common-components/src/assets/style/ob-style';
  @import "~common-components/src/static/css/mixins";

  .questionnaire-container {
    padding: 20px;
  }

  .uploader-title {
    margin-bottom: 10px;
  }

  /deep/ .uploader {
    margin-bottom: 10px;

    .ob-uploader-body {
      text-align: center;
    }

    &.disabled {
      filter: grayscale(1);
      pointer-events: none;

      .ob-uploader-body {
        background-color: $very-light-black;
        border-color: $tendersPage-carrier-ob_uploader_body_border-color;
      }

      .ob-uploader__label-helper__icon {
        opacity: .5;
      }

      .ob-uploader__label-helper {
        color: $gray-slate;
      }
    }
  }

  .empty-files {
    color: $color-grey-span;
  }

  .existing-files {
    display: flex;
    flex-wrap: wrap;
  }

  .existing-file {
    display: flex;
    align-items: center;
    justify-content: space-between;
    padding: 5px 12px;
    border-radius: 10px;
    background: $blue-250;
    margin: 0 10px 10px 0;
    min-height: 28px;
    cursor: pointer;
  }

  .existing-file-text {
    @include font-mixin(14px, 18px, 400, $color-text-base);

    text-align: center;
    position: relative;

    &:not(:last-child) {
      margin-right: 4px;
    }

    &.is-link {
      color: $color-blue-navy-blue;
    }
  }

  .existing-file-icon {
    font-size: 12px;
    font-weight: bold;
    cursor: pointer;
    color: $gray-slate;
  }
</style>
